#!/usr/bin/perl -w

use X11::GUITest qw(:ALL);

my @windows;
# my $app_title = 'xedit';
#my $app_title = 'Leginon';
# WVN 25/11/07 change
#my $app_title = '^Leginon$';
my $app_title = '^Leginon:';

# delay on clicking etc
my $delay = 500;

my $nargs=scalar(@ARGV);
if($nargs != 1){
  print "Usage: legpause.pl pause-time-secs\n";
  exit -1;
}

# top up time in seconds
#my topUpTime = 600;
my $topUpTime = $ARGV[0];

print "Pause time is ",$topUpTime, " seconds";

@windows = FindWindowLike($app_title);

my $nwindows = scalar (@windows);
print "* Number of $app_title windows found: ", $nwindows, "\n";

#for($i=0; $i<$nwindows; $i++){
#  print "Window ", $i, ":\n";
#  print $windows[$i], "\n";
#  print GetWindowName($windows[$i]), "\n";
#}

# Test code
#my @childwindows = GetChildWindows($windows[0]);
#$nchild=scalar(@childwindows);
#print "Number of child windows: ", $nchild, "\n";
#print "Child windows of 1st window:\n";
#for($i=0; $i<$nchild; $i++){
#  print "Window ", $i, ":\n";
#  print $childwindows[$i], "\n";
#  print GetWindowName($childwindows[$i]), "\n";
#}

if( $nwindows == 0 ){
  print "Error: no $app_title window found \n";
  exit -1;
}
elsif( $nwindows > 1 ){
  print "Error: more than one $app_title window found \n";
} 

my ($x, $y, $width, $height) = GetWindowPos($windows[0]);

SetEventSendDelay($delay);

my ($xmouse, $ymouse);
# click top bar to bring window into focus 
$xmouse=$width/2;
$ymouse=0;
ClickWindow $windows[0], $xmouse, $ymouse;

## test which presses quit button on xedit application (if that is the window)
#$xmouse=12;
#$ymouse=10;
#ClickWindow $windows[0], $xmouse, $ymouse;

print "Pausing Leginon\n";

print "Clicking on square targeting node\n";

# click on Square Targeting node - this is to ensure that
# clicking on the Hole node does not toggle it into inaction
#$xmouse=12;
#$ymouse=108;
$xmouse=12;
$ymouse=122;
ClickWindow $windows[0], $xmouse, $ymouse;

# click on Hole node
$xmouse=12;
$ymouse=160;
ClickWindow $windows[0], $xmouse, $ymouse;

# click on pause button
#$xmouse=268;
# changed to compromise x-position good for MSI, MSI-raster and MSI-lacey
$xmouse=273;
$ymouse=45;
ClickWindow $windows[0], $xmouse, $ymouse;

# WVN apparently had to be changed for change in desktop/ Linux version
# click on Exposure node
$xmouse=12;
#$ymouse=185;
#$ymouse=195;
# WVN 25/11/07 - changed again for Leginon 1.4.1
# $ymouse=205;
$ymouse=195;
ClickWindow $windows[0], $xmouse, $ymouse;

# click on pause button
#$xmouse=268;
$xmouse=273;
$ymouse=45;
ClickWindow $windows[0], $xmouse, $ymouse;

# sleep while waiting for top up
sleep($topUpTime);

print "Unpausing Leginon\n";

# click on Hole node
$xmouse=12;
$ymouse=160;
ClickWindow $windows[0], $xmouse, $ymouse;

# click on play button
#$xmouse=245;
$xmouse=250;
$ymouse=45;
ClickWindow $windows[0], $xmouse, $ymouse;

# click on Exposure node
$xmouse=12;
#$ymouse=185;
#$ymouse=195;
# WVN 25/11/07 - changed again for Leginon 1.4.1
#$ymouse=205;
$ymouse=195;
ClickWindow $windows[0], $xmouse, $ymouse;

# click on play button
#$xmouse=245;
$xmouse=250;
$ymouse=45;
ClickWindow $windows[0], $xmouse, $ymouse;

#while(){
#  ($xmouse, $ymouse) = GetMousePos();
#  print "Position: ", $xmouse,",", $ymouse , ",", GetWindowName(GetInputFocus()), "\n";
#  sleep 1;
#}
