#!/usr/bin/perl -w
use strict;
use sigtrap;
use Socket;  # or IO::Socket

#use IO::Socket;

use IO::Socket::INET;

use X11::GUITest qw(:ALL);

my @windows;

# WVN 25/11/07 - app title changed for Leginon 1.4.1
# my $app_title = '^Leginon$';
my $app_title = '^Leginon:';

# delay on clicking etc
my $delay = 500;
my $keyDelay = 1000;

my $state="unpaused";

sub doPause();
sub doUnpause();
sub doStop();
sub getLocalTime();

my $server;
my $client;
# WVN 21/4/08 - TEMP trying alternative server port
#my $server_port=10000;
my $server_port=60000;
my $clRequest;
my $reply;


$server = IO::Socket::INET->new(LocalPort => $server_port,
                                Type      => SOCK_STREAM,
                                Reuse     => 1,
                                Listen    => 10 )   # or SOMAXCONN
    or die "Couldn't be a tcp server on port $server_port: $!\n";

# $server -> autoflush(1);

$state="unpaused";

while ($client = $server->accept()) {
    # $client is the new connection
    $clRequest=<$client>;
    #print "Client said: ",$clRequest,"\n";
    print STDERR "Client said: ",$clRequest,"\n";
    # print $client "Hey\n";
    if($clRequest =~ /Leginon: PAUSE.*/ ){
      print $client "Pausing Leginon\n";
      # print "Pausing Leginon\n";
      doPause();
      $state="paused";
    }
    elsif($clRequest =~ /Leginon: UNPAUSE.*/ ){
      print $client "Unpausing Leginon\n";
      # print "Unpausing Leginon\n";
      doUnpause();
      $state="unpaused";
    }
    elsif($clRequest =~ /Leginon: STOP.*/ ){
      print $client "Stopping Leginon\n";
      # print "Stopping Leginon\n";
      doStop();
      $state="unpaused";
      # break; break gives errors - need to check the Perl
      close($server);
      exit 0;
    }
    else{
      print $client "Error: bad request from client\n";
    }
}

close($server);


sub doPause(){
  @windows = FindWindowLike($app_title);
                                                                                                       
  my $nwindows = scalar (@windows);
  # print "* Number of $app_title windows found: ", $nwindows, "\n";
                                                                                                       
  if( $nwindows == 0 ){
    # print "Error: no $app_title window found \n";
    exit -1;
  }
  elsif( $nwindows > 1 ){
    # print "Error: more than one $app_title window found \n";
  }
                                                                                                       
  my ($x, $y, $width, $height) = GetWindowPos($windows[0]);
                                                                                                       
  SetEventSendDelay($delay);
                                                                                                       
  my ($xmouse, $ymouse);
  # click top bar to bring window into focus
  $xmouse=$width/2;
  $ymouse=0;
  ClickWindow $windows[0], $xmouse, $ymouse;

  my $currTime = getLocalTime();
  #print "Pausing Leginon at ", $currTime, "\n";
  print STDERR "Pausing Leginon at ", $currTime, "\n";
                                                                                                       
  # click on Square Targeting node - this is to ensure that
  # clicking on the Hole node does not toggle it into inaction
  $xmouse=12;
  $ymouse=108;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on Hole node
  $xmouse=12;
  $ymouse=160;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on pause button
  # $xmouse=268;
  $xmouse=273;
  $ymouse=45;
  ClickWindow $windows[0], $xmouse, $ymouse;
  # click on Exposure node
  $xmouse=12;
  #$ymouse=185;
  #$ymouse=195;
  # WVN 25/11/07 - changed again for Leginon 1.4.1
  # $ymouse=205;
  $ymouse=195;
  ClickWindow $windows[0], $xmouse, $ymouse;

  # click on pause button
  # $xmouse=268;
  $xmouse=273;
  $ymouse=45;
  ClickWindow $windows[0], $xmouse, $ymouse;
}

sub doUnpause(){
  @windows = FindWindowLike($app_title);
                                                                                                       
  my $nwindows = scalar (@windows);
  # print "* Number of $app_title windows found: ", $nwindows, "\n";
                                                                                                       
  if( $nwindows == 0 ){
    # print "Error: no $app_title window found \n";
    exit -1;
  }
  elsif( $nwindows > 1 ){
    # print "Error: more than one $app_title window found \n";
  }
                                                                                                       
  my ($x, $y, $width, $height) = GetWindowPos($windows[0]);
                                                                                                       
  SetEventSendDelay($delay);
                                                                                                       
  my ($xmouse, $ymouse);
  # click top bar to bring window into focus
  $xmouse=$width/2;
  $ymouse=0;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  my $currTime = getLocalTime();
  #print "Unpausing Leginon at ", $currTime, "\n";
  print STDERR "Unpausing Leginon at ", $currTime, "\n";
                                                                                                       
  # click on Square Targeting node - this is to ensure that
  # clicking on the Hole node does not toggle it into inaction
  $xmouse=12;
  $ymouse=108;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on Hole node
  $xmouse=12;
  $ymouse=160;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on play button
  # $xmouse=245;
  $xmouse=250;
  $ymouse=45;
  ClickWindow $windows[0], $xmouse, $ymouse;

  # click on Exposure node
  $xmouse=12;
  #$ymouse=185;
  #$ymouse=195;
  # WVN 25/11/07 - changed again for Leginon 1.4.1
  # $ymouse=205;
  $ymouse=195;
  ClickWindow $windows[0], $xmouse, $ymouse;
                                                                                                       
  # click on play button
  # $xmouse=245;
  $xmouse=250;
  $ymouse=45;
  ClickWindow $windows[0], $xmouse, $ymouse;
}

sub doStop(){
  @windows = FindWindowLike($app_title);
                                                                                                       
  my $nwindows = scalar (@windows);
  # print "* Number of $app_title windows found: ", $nwindows, "\n";
                                                                                                       
  if( $nwindows == 0 ){
    # print "Error: no $app_title window found \n";
    exit -1;
  }
  elsif( $nwindows > 1 ){
    # print "Error: more than one $app_title window found \n";
  }
                                                                                                       
  my ($x, $y, $width, $height) = GetWindowPos($windows[0]);
                                                                                                       
  SetEventSendDelay($delay);
                                                                                                       
  my ($xmouse, $ymouse);
  # click top bar to bring window into focus
  $xmouse=$width/2;
  $ymouse=0;
  ClickWindow $windows[0], $xmouse, $ymouse;

  my $currTime = getLocalTime();
  # print "Stopping Leginon", $currTime, "\n";
  print STDERR "Stopping Leginon", $currTime, "\n";

  SetKeySendDelay($keyDelay);

  # SendKeys('%(f)x ');
  # WVN - "^(u)" is dirty hack to give Ctrl-U in order to
  # remove x's which are sent to new window with focus when
  # Leginon has quit
  SendKeys('%(f)x^(u)');

}

sub getLocalTime(){
  my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
  my @weekDays = qw(Sun Mon Tue Wed Thu Fri Sat Sun);
  my $second, my $minute, my $hour, my $dayOfMonth, my $month, my $yearOffset, my $dayOfWeek, my $dayOfYear, my $daylightSavings;
  ($second, $minute, $hour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings) = localtime();
  my $year = 1900 + $yearOffset;
  my $theTime = "$hour:$minute:$second, $weekDays[$dayOfWeek] $months[$month] $dayOfMonth, $year";
  return $theTime;
}

