#!/usr/bin/env perl

use X11::GUITest qw(:ALL);

use legpause::config qw(:ALL);

if(@ARGV != 1){
  die "Usage: legpause_config.pl <config-file>\n";
}

my ($outFilename);

$outFilename=$ARGV[0];

open(FILEOUT, ">$outFilename");
print "Writing to config file: $outFilename\n";


my ($appName);

print "Please enter beginning of name of Leginon GUI -\n";
print "this will be on the title bar at the top of the GUI's main window\n";

$appName=<STDIN>;
chomp($appName);

print "Leginon GUI name is: $appName\n";

@windows = FindWindowLike($appName);

my $nwindows = scalar (@windows);
print "* Number of $appName windows found: ", $nwindows, "\n";

if( $nwindows == 0 ){
  print "Error: no $appName window found \n";
  exit -1;
}
elsif( $nwindows > 1 ){
  print "Error: more than one $appName window found \n";
  print "Either the name is not sufficiently specific or you have multiple\n";
  print "Leginon GUIs running\n";
  exit -2;
} 

my ($xapp, $yapp, $width, $height) = GetWindowPos($windows[0]);

SetEventSendDelay($delay);

my ($xmouse, $ymouse);
# click top bar to bring window into focus 
$xmouse=$width/2;
$ymouse=0;
ClickWindow $windows[0], $xmouse, $ymouse;

my ($x, $y);
($x, $y)=GetGUIElementPosition("Square Targeting node", $xapp, $yapp);
print FILEOUT "Square Targeting node: $x,$y\n";
($x, $y)=GetGUIElementPosition("Hole node", $xapp, $yapp);
print FILEOUT "Hole node: $x,$y\n";
($x, $y)=GetGUIElementPosition("pause button", $xapp, $yapp);
print FILEOUT "Hole node pause button: $x,$y\n";
($x, $y)=GetGUIElementPosition("play button", $xapp, $yapp);
print FILEOUT "Hole node play button: $x,$y\n";
($x, $y)=GetGUIElementPosition("Exposure node", $xapp, $yapp);
print FILEOUT "Exposure node: $x,$y\n";
($x, $y)=GetGUIElementPosition("pause button", $xapp, $yapp);
print FILEOUT "Exposure node pause button: $x,$y\n";
($x, $y)=GetGUIElementPosition("play button", $xapp, $yapp);
print FILEOUT "Exposure node play button: $x,$y\n";

close(FILEOUT);

exit 0;

sub GetGUIElementPosition{
  my ($name, $x, $y, $scrNum, $sleepTime);
  $sleepTime=2;

  $name=$_[0];
  $xapp=$_[1];
  $yapp=$_[2];

  sleep $sleepTime;
  print "Please click on the $name\n";
  
  print IsMouseButtonPressed(M_LEFT);
  print "\n";
  
  while(IsMouseButtonPressed(M_LEFT)==0){
    ($x, $y, $scrNum)=GetMousePos();
  }
  
  $x=$x-$xapp;
  $y=$y-$yapp;
  print "For $name got x= $x y = $y\n";

  return($x,$y); 
}
