#!/usr/bin/perl -w
use strict;
use sigtrap;
use Socket;  # or IO::Socket

#use IO::Socket;

use IO::Socket::INET;

use X11::GUITest qw(:ALL);

use legpause::legpause qw(:ALL);
use legpause::config qw(:ALL);

my $nargs=scalar(@ARGV);
if($nargs != 1){
  print "Usage: lpserver.pl config-file\n";
  exit -1;
}

my $configFileName=$ARGV[0];

print "Reading config file: $configFileName";

my %temphash;
%temphash=config::readConfig($configFileName);
legpause::setConfigHash(\%temphash);

my @windows;

# WVN 25/11/07 - app title changed for Leginon 1.4.1
# my $app_title = '^Leginon$';
my $app_title = '^Leginon:';

## delay on clicking etc
#my $delay = 500;
#my $keyDelay = 1000;

my $state="unpaused";

my $server;
my $client;
# WVN 21/4/08 - TEMP trying alternative server port
#my $server_port=10000;
my $server_port=60000;
my $clRequest;
my $reply;


$server = IO::Socket::INET->new(LocalPort => $server_port,
                                Type      => SOCK_STREAM,
                                Reuse     => 1,
                                Listen    => 10 )   # or SOMAXCONN
    or die "Couldn't be a tcp server on port $server_port: $!\n";

# $server -> autoflush(1);

$state="unpaused";

while ($client = $server->accept()) {
    # $client is the new connection
    $clRequest=<$client>;
    #print "Client said: ",$clRequest,"\n";
    print STDERR "Client said: ",$clRequest,"\n";
    # print $client "Hey\n";
    if($clRequest =~ /Leginon: PAUSE.*/ ){
      print $client "Pausing Leginon\n";
      # print "Pausing Leginon\n";
      legpause::doPause();
      $state="paused";
    }
    elsif($clRequest =~ /Leginon: UNPAUSE.*/ ){
      print $client "Unpausing Leginon\n";
      # print "Unpausing Leginon\n";
      legpause::doUnpause();
      $state="unpaused";
    }
    elsif($clRequest =~ /Leginon: STOP.*/ ){
      print $client "Stopping Leginon\n";
      # print "Stopping Leginon\n";
      legpause::doStop();
      $state="unpaused";
      # break; break gives errors - need to check the Perl
      close($server);
      exit 0;
    }
    else{
      print $client "Error: bad request from client\n";
    }
}

close($server);
